Index: uspace/lib/c/generic/io/io.c
===================================================================
--- uspace/lib/c/generic/io/io.c	(revision 1b20da07baaa3e3c424f62c927274e676e4295cd)
+++ uspace/lib/c/generic/io/io.c	(revision 8565a42398543d14e36b2df6f7a70c6237b458f8)
@@ -119,5 +119,5 @@
 		list_append(&stdin->link, &files);
 	}
-	
+
 	int outfd = inbox_get("stdout");
 	if (outfd >= 0) {
@@ -133,5 +133,5 @@
 		list_append(&stdout->link, &files);
 	}
-	
+
 	int errfd = inbox_get("stderr");
 	if (errfd >= 0) {
@@ -165,8 +165,8 @@
 		return false;
 	}
-	
+
 	if ((*mp == 'b') || (*mp == 't'))
 		mp++;
-	
+
 	bool plus;
 	if (*mp == '+') {
@@ -175,5 +175,5 @@
 	} else
 		plus = false;
-	
+
 	if (*mp != 0) {
 		errno = EINVAL;
@@ -183,5 +183,5 @@
 	*create = false;
 	*truncate = false;
-	
+
 	/* Parse first character of fmode and determine mode for vfs_open(). */
 	switch (fmode[0]) {
@@ -209,5 +209,5 @@
 		return false;
 	}
-	
+
 	return true;
 }
@@ -241,5 +241,5 @@
 {
 	/* FIXME: Use more complex rules for setting buffering options. */
-	
+
 	switch (stream->fd) {
 	case 1:
@@ -259,5 +259,5 @@
 {
 	assert(stream->buf == NULL);
-	
+
 	stream->buf = malloc(stream->buf_size);
 	if (stream->buf == NULL) {
@@ -265,5 +265,5 @@
 		return EOF;
 	}
-	
+
 	stream->buf_head = stream->buf;
 	stream->buf_tail = stream->buf;
@@ -285,5 +285,5 @@
 	if (!parse_mode(fmode, &mode, &create, &truncate))
 		return NULL;
-	
+
 	/* Open file. */
 	FILE *stream = malloc(sizeof(FILE));
@@ -311,5 +311,5 @@
 		return NULL;
 	}
-	
+
 	if (truncate) {
 		rc = vfs_resize(file, 0);
@@ -331,7 +331,7 @@
 	_setvbuf(stream);
 	stream->ungetc_chars = 0;
-	
+
 	list_append(&stream->link, &files);
-	
+
 	return stream;
 }
@@ -345,5 +345,5 @@
 		return NULL;
 	}
-	
+
 	stream->fd = fd;
 	stream->pos = 0;
@@ -355,7 +355,7 @@
 	_setvbuf(stream);
 	stream->ungetc_chars = 0;
-	
+
 	list_append(&stream->link, &files);
-	
+
 	return stream;
 }
@@ -365,20 +365,20 @@
 {
 	errno_t rc = 0;
-	
+
 	fflush(stream);
-	
+
 	if (stream->sess != NULL)
 		async_hangup(stream->sess);
-	
+
 	if (stream->fd >= 0)
 		rc = vfs_put(stream->fd);
-	
+
 	list_remove(&stream->link);
-	
+
 	if (rc != EOK) {
 		errno = rc;
 		return EOF;
 	}
-	
+
 	return 0;
 }
@@ -387,10 +387,10 @@
 {
 	int rc = _fclose_nofree(stream);
-	
+
 	if ((stream != &stdin_null)
 	    && (stream != &stdout_kio)
 	    && (stream != &stderr_kio))
 		free(stream);
-	
+
 	return rc;
 }
@@ -399,10 +399,10 @@
 {
 	FILE *nstr;
-	
+
 	if (path == NULL) {
 		/* Changing mode is not supported */
 		return NULL;
 	}
-	
+
 	(void) _fclose_nofree(stream);
 	nstr = fopen(path, mode);
@@ -411,11 +411,11 @@
 		return NULL;
 	}
-	
+
 	list_remove(&nstr->link);
 	*stream = *nstr;
 	list_append(&stream->link, &files);
-	
+
 	free(nstr);
-	
+
 	return stream;
 }
@@ -659,10 +659,10 @@
 			return 0; /* Errno set by _fallocbuf(). */
 	}
-	
+
 	data = (uint8_t *) buf;
 	bytes_left = size * nmemb;
 	total_written = 0;
 	need_flush = false;
-	
+
 	while ((!stream->error) && (bytes_left > 0)) {
 		buf_free = stream->buf_size - (stream->buf_head - stream->buf);
@@ -671,13 +671,13 @@
 		else
 			now = bytes_left;
-		
+
 		for (i = 0; i < now; i++) {
 			b = data[i];
 			stream->buf_head[i] = b;
-			
+
 			if ((b == '\n') && (stream->btype == _IOLBF))
 				need_flush = true;
 		}
-		
+
 		data += now;
 		stream->buf_head += now;
@@ -686,5 +686,5 @@
 		total_written += now;
 		stream->buf_state = _bs_write;
-		
+
 		if (buf_free == 0) {
 			/* Only need to drain buffer. */
@@ -697,5 +697,5 @@
 	if (need_flush)
 		fflush(stream);
-	
+
 	return (total_written / size);
 }
@@ -705,14 +705,14 @@
 	char buf[STR_BOUNDS(1)];
 	size_t sz = 0;
-	
+
 	if (chr_encode(c, buf, &sz, STR_BOUNDS(1)) == EOK) {
 		size_t wr = fwrite(buf, 1, sz, stream);
-		
+
 		if (wr < sz)
 			return EOF;
-		
+
 		return (int) c;
 	}
-	
+
 	return EOF;
 }
@@ -739,5 +739,5 @@
 {
 	char c;
-	
+
 	/* This could be made faster by only flushing when needed. */
 	if (stdout)
@@ -745,8 +745,8 @@
 	if (stderr)
 		fflush(stderr);
-	
+
 	if (fread(&c, sizeof(char), 1, stream) < sizeof(char))
 		return EOF;
-	
+
 	return (int) c;
 }
@@ -841,5 +841,5 @@
 	if (stream->error)
 		return EOF;
-	
+
 	_fflushbuf(stream);
 	if (stream->error) {
@@ -876,5 +876,5 @@
 	if (stream->error)
 		return EOF;
-	
+
 	_fflushbuf(stream);
 	if (stream->error) {
@@ -882,10 +882,10 @@
 		return EOF;
 	}
-	
+
 	if (stream->kio) {
 		kio_update();
 		return 0;
 	}
-	
+
 	if ((stream->fd >= 0) && (stream->need_sync)) {
 		errno_t rc;
@@ -904,5 +904,5 @@
 		return 0;
 	}
-	
+
 	return 0;
 }
@@ -930,5 +930,5 @@
 		return EOF;
 	}
-	
+
 	return stream->fd;
 }
@@ -939,8 +939,8 @@
 		if (stream->sess == NULL)
 			stream->sess = vfs_fd_session(stream->fd, iface);
-		
+
 		return stream->sess;
 	}
-	
+
 	return NULL;
 }
@@ -952,5 +952,5 @@
 		return EOK;
 	}
-	
+
 	return ENOENT;
 }